Package com.pixelmed.dicom

## Class FloatDoubleAttribute

- java.lang.Object
- - com.pixelmed.dicom.Attribute
  - - com.pixelmed.dicom.FloatDoubleAttribute

-     public class FloatDoubleAttribute
      extends Attribute

  A concrete class specializing `Attribute` for Float Double (FD) attributes.

  Though an instance of this class may be created using its constructors, there is also a factory class, `AttributeFactory`.

  See Also:
    `Attribute`, `AttributeFactory`, `AttributeList`

- - ### Field Summary

    - ### Fields inherited from class com.pixelmed.dicom.Attribute

      `valueLength, valueMultiplicity`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FloatDoubleAttribute​(AttributeTag t)` | Construct an (empty) attribute.
    `FloatDoubleAttribute​(AttributeTag t, long vl, DicomInputStream i)` | Read an attribute from an input stream.
    `FloatDoubleAttribute​(AttributeTag t, java.lang.Long vl, DicomInputStream i)` | Read an attribute from an input stream.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addValue​(double v)` | Add a(nother) double value after any existing values of this attribute.
    `void` | `addValue​(float v)` | Add a(nother) float value after any existing values of this attribute.
    `void` | `addValue​(int v)` | Add a(nother) int value after any existing values of this attribute.
    `void` | `addValue​(long v)` | Add a(nother) long value after any existing values of this attribute.
    `void` | `addValue​(short v)` | Add a(nother) short value after any existing values of this attribute.
    `void` | `addValue​(java.lang.String v)` | Add a(nother) `String` value after any existing values of this attribute.
    `double[]` | `getDoubleValues()` | Get the values of this attribute as a double array.
    `java.lang.String[]` | `getStringValues​(java.text.NumberFormat format)` | Get the values of this attribute as strings.
    `byte[]` | `getVR()` | Get the value representation of this attribute (FD).
    `void` | `removeValues()` | Remove any existing values, making the attribute empty (zero length).
    `java.lang.String` | `toString​(DicomDictionary dictionary)` | Dump the contents of the attribute as a human-readable string.
    `void` | `write​(DicomOutputStream o)` | Write the entire attribute (including values) to the output stream.

    - ### Methods inherited from class com.pixelmed.dicom.Attribute

      `addValue, getByteValues, getByteValues, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDoubleValues, getDoubleValues, getElement, getFloatValues, getFloatValues, getFloatValues, getGroup, getIntegerValues, getIntegerValues, getIntegerValues, getLengthOfBaseOfEncodedAttribute, getLengthOfEncodedValue, getLengthOfEntireEncodedAttribute, getLongValues, getLongValues, getLongValues, getOriginalStringValues, getPaddedVL, getShortValues, getSingleDoubleValueOrDefault, getSingleDoubleValueOrDefault, getSingleDoubleValueOrDefault, getSingleFloatValueOrDefault, getSingleFloatValueOrDefault, getSingleFloatValueOrDefault, getSingleIntegerValueOrDefault, getSingleIntegerValueOrDefault, getSingleIntegerValueOrDefault, getSingleLongValueOrDefault, getSingleLongValueOrDefault, getSingleLongValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getStringValues, getStringValues, getStringValues, getStringValues, getStringValues, getTag, getVL, getVM, getVRAsString, isValid, repairValues, setValue, setValue, setValue, setValue, setValue, setValue, setValue, setValues, setValues, setValues, setValues, setValues, setValues, setValues, toString, writeBase`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FloatDoubleAttribute

          public FloatDoubleAttribute​(AttributeTag t)

      Construct an (empty) attribute.

      Parameters:
        `t` - the tag of the attribute

    - #### FloatDoubleAttribute

          public FloatDoubleAttribute​(AttributeTag t,
                                      long vl,
                                      DicomInputStream i)
                               throws java.io.IOException,
                                      DicomException

      Read an attribute from an input stream.

      Parameters:
        `t` - the tag of the attribute
        `vl` - the value length of the attribute
        `i` - the input stream
      Throws:
        `java.io.IOException` - if an I/O error occurs
        `DicomException` - if error in DICOM encoding

    - #### FloatDoubleAttribute

          public FloatDoubleAttribute​(AttributeTag t,
                                      java.lang.Long vl,
                                      DicomInputStream i)
                               throws java.io.IOException,
                                      DicomException

      Read an attribute from an input stream.

      Parameters:
        `t` - the tag of the attribute
        `vl` - the value length of the attribute
        `i` - the input stream
      Throws:
        `java.io.IOException` - if an I/O error occurs
        `DicomException` - if error in DICOM encoding

  - ### Method Detail

    - #### write

          public void write​(DicomOutputStream o)
                     throws DicomException,
                            java.io.IOException

      Description copied from class: `Attribute`

      Write the entire attribute (including values) to the output stream.

      Specified by:
        `write` in class `Attribute`
      Parameters:
        `o` - the output stream
      Throws:
        `DicomException` - if error in DICOM encoding
        `java.io.IOException` - if an I/O error occurs

    - #### toString

          public java.lang.String toString​(DicomDictionary dictionary)

      Description copied from class: `Attribute`

      Dump the contents of the attribute as a human-readable string.

      No new line is appended.

      The result is of the form:

           (0xgggg,0xeeee) Name VR=<XX> VL=<0xnnnn> <...>

      For example:

           (0x0018,0x0020) ScanningSequence VR=<CS> VL=<0x2> <GR>

      Overrides:
        `toString` in class `Attribute`
      Parameters:
        `dictionary` - the dictionary to use to look up the name
      Returns:
        a single `String` value

    - #### getStringValues

          public java.lang.String[] getStringValues​(java.text.NumberFormat format)
                                             throws DicomException

      Description copied from class: `Attribute`

      Get the values of this attribute as strings.

      The strings may have been cleaned up into a canonical form, such as to remove padding as well as numbers formatted.

      Overrides:
        `getStringValues` in class `Attribute`
      Parameters:
        `format` - the format to use for each numerical or decimal value
      Returns:
        the values as an array of `String`
      Throws:
        `DicomException` - thrown if values are not available (such as not supported for this concrete attribute class)

    - #### getDoubleValues

          public double[] getDoubleValues()
                                   throws DicomException

      Description copied from class: `Attribute`

      Get the values of this attribute as a double array.

      Overrides:
        `getDoubleValues` in class `Attribute`
      Returns:
        the values as an array of double
      Throws:
        `DicomException` - thrown if values are not available (such as not supported for this concrete attribute class)

    - #### addValue

          public void addValue​(double v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) double value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` - value to add
      Throws:
        `DicomException` - thrown if value of this type is not valid for this concrete attribute class

    - #### addValue

          public void addValue​(float v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) float value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` - value to add
      Throws:
        `DicomException` - thrown if value of this type is not valid for this concrete attribute class

    - #### addValue

          public void addValue​(short v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) short value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` - value to add
      Throws:
        `DicomException` - thrown if value of this type is not valid for this concrete attribute class

    - #### addValue

          public void addValue​(int v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) int value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` - value to add
      Throws:
        `DicomException` - thrown if value of this type is not valid for this concrete attribute class

    - #### addValue

          public void addValue​(long v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) long value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` - value to add
      Throws:
        `DicomException` - thrown if value of this type is not valid for this concrete attribute class

    - #### addValue

          public void addValue​(java.lang.String v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) `String` value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` - value to add
      Throws:
        `DicomException` - thrown if value of this type is not valid for this concrete attribute class

    - #### removeValues

          public void removeValues()

      Description copied from class: `Attribute`

      Remove any existing values, making the attribute empty (zero length).

      Specified by:
        `removeValues` in class `Attribute`

    - #### getVR

          public byte[] getVR()

      Get the value representation of this attribute (FD).

      Overrides:
        `getVR` in class `Attribute`
      Returns:
        'F','D' in ASCII as a two byte array; see `ValueRepresentation`